﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Tonky_Utilities.Windows;
using System.Diagnostics;

namespace Gioco_15
{
    /// <summary>
    /// Logica di interazione per MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private const string c_Mosse = "Numero Mosse: ";

        clsGioco partita = new clsGioco();

        public MainWindow()
        {
            InitializeComponent();
            partita.NewGame_Started += Partita_NewGame_Started;
            partita.NewGame_Starting += Partita_NewGame_Starting;
            partita.MossaNonPossibile += Partita_MossaNonPossibile;
            partita.MossaPossibile += Partita_MossaPossibile;
            partita.MossaTerminata += Partita_MossaTerminata;
            partita.GameOver += Partita_GameOver;
            PosizioniIniziale();
        }


        #region "Gestione Eventi Gioco Controller"

        private void Partita_MossaPossibile(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
        }

        private void Partita_MossaNonPossibile(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
            //MessageBox.Show("Mona te ga sbajà!");
        }

        private void Partita_NewGame_Starting(object sender, EventArgs e)
        {
            //MessageBox.Show( "Sto iniziando una nuova partita :D !",
            //                "Inizio partita nuova", MessageBoxButton.OK, 
            //                MessageBoxImage.Information );
        }

        private void Partita_NewGame_Started(object sender, EventArgs e)
        {
            MessageBox.Show("Grazie per aver iniziato una nuova partita!",
                            "Nuova Partita", MessageBoxButton.OK,
                            MessageBoxImage.Information);
        }

        private void Partita_MossaTerminata(object sender, EventArgs e)
        {
            mnuMosse.Header = c_Mosse + partita.ContaMosse.ToString();
        }

        private void Partita_GameOver(object sender, EventArgs e)
        {
            MessageBox.Show(string.Format("Complimenti la partita è terminata." + Environment.NewLine +
                            "Hai vinto in {0} mosse.", partita.ContaMosse),
                            "GAME OVER",
                            MessageBoxButton.OK, MessageBoxImage.Information);
        }
        #endregion

        private void NewGame_Click(object sender, RoutedEventArgs e)
        {
            partita.NuovaPartita();
            mnuMosse.Header = c_Mosse + partita.ContaMosse.ToString();
            VisulizzaStatusQuo();
        }

        /// <summary>
        /// Effettua il caricamento dei valori iniziali sulla View.
        /// </summary>
        private void PosizioniIniziale()
        {
            //------------------------------------------------------------------------------------------------
            img_00.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/1.png"));
            img_00.Visibility = Visibility.Visible;

            img_01.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/2.png"));
            img_01.Visibility = Visibility.Visible;

            img_02.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/3.png"));
            img_02.Visibility = Visibility.Visible;

            img_03.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/4.png"));
            img_03.Visibility = Visibility.Visible;

            //------------------------------------------------------------------------------------------------
            img_10.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/5.png"));
            img_10.Visibility = Visibility.Visible;

            img_11.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/6.png"));
            img_11.Visibility = Visibility.Visible;

            img_12.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/7.png"));
            img_12.Visibility = Visibility.Visible;

            img_13.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/8.png"));
            img_13.Visibility = Visibility.Visible;

            //------------------------------------------------------------------------------------------------
            img_20.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/9.png"));
            img_20.Visibility = Visibility.Visible;

            img_21.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/10.png"));
            img_21.Visibility = Visibility.Visible;

            img_22.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/11.png"));
            img_22.Visibility = Visibility.Visible;

            img_23.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/12.png"));
            img_23.Visibility = Visibility.Visible;

            //------------------------------------------------------------------------------------------------
            img_30.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/13.png"));
            img_30.Visibility = Visibility.Visible;

            img_31.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/14.png"));
            img_31.Visibility = Visibility.Visible;

            img_32.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/15.png"));
            img_32.Visibility = Visibility.Visible;

            //------------------------------------------------------------------------------------------------
            //-- VUOTO
            //------------------------------------------------------------------------------------------------
            img_33.Source = null;
            img_33.Visibility = Visibility.Visible;
        }

        /// <summary>
        /// Effettua la visualizzazione ed il refresh del tabellone di gioco sulla View
        /// </summary>
        private void VisulizzaStatusQuo()
        {
            int[,] StatusQuo = new int[4, 4];
            StatusQuo = partita.StatusQuo();

            // Questo si potrebbe anche modificare senza cercare l'immagini sulla Windows
            // Basterebbe due semplici cicli for riga/colonna per replicare lo StatusQuo 
            // della mia classe
            // Altra soluzione ancora utilizzare le lambda expression per recuperare tutte le immagini
            // magari filtrate per riga/colonna specifica e poi carica le immagini.
            foreach (Image img in Lib_Tonky.FindVisualChildren<Image>(this))
            {
                //Debug.Print(img.Name);
                int row = Grid.GetRow(img);
                int col = Grid.GetColumn(img);

                if (StatusQuo[row, col] != 0)
                {
                    img.Source = new BitmapImage(new Uri(@"pack://siteoforigin:,,,/immagini/" + StatusQuo[row, col].ToString() + ".png"));
                    img.Visibility = Visibility.Visible;
                }
                else
                    img.Source = null;
            }
        }


        #region "Gestione del Click per la mossa"
        private void r00_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r00 Clicked");
            int row = Grid.GetRow(r00);
            int col = Grid.GetColumn(r00);
            EseguiMossa(row, col);
        }

        private void r01_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r01 Clicked");
            int row = Grid.GetRow(r01);
            int col = Grid.GetColumn(r01);
            EseguiMossa(row, col);
        }

        private void r02_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r02 Clicked");
            int row = Grid.GetRow(r02);
            int col = Grid.GetColumn(r02);
            EseguiMossa(row, col);
        }

        private void r03_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r03 Clicked");
            int row = Grid.GetRow(r03);
            int col = Grid.GetColumn(r03);
            EseguiMossa(row, col);
        }

        private void r10_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r10 Clicked");
            int row = Grid.GetRow(r10);
            int col = Grid.GetColumn(r10);
            EseguiMossa(row, col);
        }

        private void r11_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r11 Clicked");
            int row = Grid.GetRow(r11);
            int col = Grid.GetColumn(r11);
            EseguiMossa(row, col);
        }

        private void r12_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r12 Clicked");
            int row = Grid.GetRow(r12);
            int col = Grid.GetColumn(r12);
            EseguiMossa(row, col);
        }

        private void r13_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r13 Clicked");
            int row = Grid.GetRow(r13);
            int col = Grid.GetColumn(r13);
            EseguiMossa(row, col);
        }

        private void r20_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r20 Clicked");
            int row = Grid.GetRow(r20);
            int col = Grid.GetColumn(r20);
            EseguiMossa(row, col);
        }

        private void r21_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r21 Clicked");
            int row = Grid.GetRow(r21);
            int col = Grid.GetColumn(r21);
            EseguiMossa(row, col);
        }

        private void r22_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r22 Clicked");
            int row = Grid.GetRow(r22);
            int col = Grid.GetColumn(r22);
            EseguiMossa(row, col);
        }

        private void r23_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r23 Clicked");
            int row = Grid.GetRow(r23);
            int col = Grid.GetColumn(r23);
            EseguiMossa(row, col);
        }

        private void r30_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r30 Clicked");
            int row = Grid.GetRow(r30);
            int col = Grid.GetColumn(r30);
            EseguiMossa(row, col);
        }

        private void r31_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r31 Clicked");
            int row = Grid.GetRow(r31);
            int col = Grid.GetColumn(r31);
            EseguiMossa(row, col);
        }

        private void r32_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r32 Clicked");
            int row = Grid.GetRow(r32);
            int col = Grid.GetColumn(r32);
            EseguiMossa(row, col);
        }

        private void r33_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            //Debug.Print("r33 Clicked");
            int row = Grid.GetRow(r33);
            int col = Grid.GetColumn(r33);
            EseguiMossa(row, col);
        }

        #endregion

        /// <summary>
        /// Provvede alla richiesta al Controller per l'esecuzione 
        /// della mossa e ricarica il layout grafico sulla View.
        /// </summary>
        /// <param name="row"></param>
        /// <param name="col"></param>
        void EseguiMossa(int row, int col)
        {
            clsGioco.TipoMossa DirezioneMossa = partita.Mossa(row, col);
            VisulizzaStatusQuo();
        }
    }
}
